-- A palindromic number reads the same both ways. The largest palindrome made from the product of two 2-digit numbers is 9009 = 91 × 99.
--
-- Find the largest palindrome made from the product of two 3-digit numbers.

module P004 (p004) where

isPalindrome :: Int -> Bool
isPalindrome n = show n == reverse (show n)

maxPalindrome :: Int
maxPalindrome =
  maximum . filter isPalindrome $ (*) <$> [100 .. 999] <*> [100 .. 999]

p004 :: IO ()
p004 = do
  let result = maxPalindrome
  putStrLn $
    "Project Euler, Problem 4\n"
      ++ "Answer: "
      ++ show result
